apiVersion: source.toolkit.fluxcd.io/v1beta1
kind: HelmRepository
metadata:
  name: hyperswitch-helm
  labels:
    app.kubernetes.io/name: {{ template "hyperswitch.name" . }}
    helm.sh/chart: {{ .Chart.Name }}-{{ .Chart.Version }}
    app.kubernetes.io/instance: {{ .Release.Name }}
    app.kubernetes.io/managed-by: {{ .Release.Service }}
spec:
  interval: 5m
  url: https://github.com/juspay/hyperswitch-helm
---
apiVersion: helm.toolkit.fluxcd.io/v2beta1
kind: HelmRelease
metadata:
  name: {{ .Release.Name }}-release
  labels:
    app.kubernetes.io/name: {{ template "hyperswitch.name" . }}
    helm.sh/chart: {{ .Chart.Name }}-{{ .Chart.Version }}
    app.kubernetes.io/instance: {{ .Release.Name }}
    app.kubernetes.io/managed-by: {{ .Release.Service }}
spec:
  interval: 5m
  chart:
    spec:
      chart: hyperswitch-stack
      version: {{ .Chart.Version }}
      sourceRef:
        apiVersion: source.toolkit.fluxcd.io/v1beta1
        kind: HelmRepository
        name: hyperswitch-helm
  values:
    replicaCount: 1

    image:
      repository: nginx
      pullPolicy: IfNotPresent
      # Overrides the image tag whose default is the chart appVersion.
      tag: ""

    imagePullSecrets: []
    nameOverride: ""
    fullnameOverride: ""

    serviceAccount:
      # Specifies whether a service account should be created
      create: true
      # Automatically mount a ServiceAccount's API credentials?
      automount: true
      # Annotations to add to the service account
      annotations: {}
      # The name of the service account to use.
      # If not set and create is true, a name is generated using the fullname template
      name: ""

    podAnnotations: {}
    podLabels: {}

    podSecurityContext: {}
      # fsGroup: 2000

    securityContext: {}
      # capabilities:
      #   drop:
      #   - ALL
      # readOnlyRootFilesystem: true
      # runAsNonRoot: true
      # runAsUser: 1000

    service:
      type: ClusterIP
      port: 80

    ingress:
      enabled: false
      className: ""
      annotations: {}
        # kubernetes.io/ingress.class: nginx
        # kubernetes.io/tls-acme: "true"
      hosts:
        - host:
          paths:
            - path: /
              pathType: ImplementationSpecific
      tls: []
      #  - secretName: chart-example-tls
      #    hosts:
      #      - chart-example.local

    resources: {}
      # We usually recommend not to specify default resources and to leave this as a conscious
      # choice for the user. This also increases chances charts run on environments with little
      # resources, such as Minikube. If you do want to specify resources, uncomment the following
      # lines, adjust them as necessary, and remove the curly braces after 'resources:'.
      # limits:
      #   cpu: 100m
      #   memory: 128Mi
      # requests:
      #   cpu: 100m
      #   memory: 128Mi

    autoscaling:
      enabled: false
      minReplicas: 1
      maxReplicas: 100
      targetCPUUtilizationPercentage: 80
      # targetMemoryUtilizationPercentage: 80

    # Additional volumes on the output Deployment definition.
    volumes: []
    # - name: foo
    #   secret:
    #     secretName: mysecret
    #     optional: false

    # Additional volumeMounts on the output Deployment definition.
    volumeMounts: []
    # - name: foo
    #   mountPath: "/etc/foo"
    #   readOnly: true

    nodeSelector: {}

    tolerations: []

    affinity: {}

    # loadbalancer security group
    loadBalancer:
      targetSecurityGroup: &lb_security_group lg-security-group

    services:
      router:
        host: &router_host http://localhost:8080
      sdk:
        host: &web_sdk_host http://localhost:9090

    hyperswitchsdk:
      enabled: true
      podAnnotations:
        "helm.sh/hook": post-install,post-upgrade
        "helm.sh/hook-weight": "-5"
        "helm.sh/hook-delete-policy": hook-succeeded
      autoBuild:
        forceBuild: true
        gitCloneParam:
          gitVersion: 0.80.0
        nginxConfig:
          extraPath: v0
        buildParam:
          envSdkUrl: *web_sdk_host
          envBackendUrl: *router_host
      service:
        port: 9090
      loadBalancer:
        targetSecurityGroup: "loadbalancer-sg"
      ingress:
        enabled: true
        className: "alb"
        apiVersion: networking.k8s.io/v1
        annotations:
          alb.ingress.kubernetes.io/backend-protocol: HTTP
          alb.ingress.kubernetes.io/backend-protocol-version: HTTP1
          alb.ingress.kubernetes.io/group.name: hyperswitch-web-alb-ingress-group
          alb.ingress.kubernetes.io/ip-address-type: ipv4
          alb.ingress.kubernetes.io/listen-ports: '[{"HTTP": 80}]'
          alb.ingress.kubernetes.io/load-balancer-name: hyperswitch-web
          alb.ingress.kubernetes.io/scheme: internet-facing
          alb.ingress.kubernetes.io/security-groups: *lb_security_group
          alb.ingress.kubernetes.io/tags: stack=hyperswitch-lb
          alb.ingress.kubernetes.io/target-type: ip
        hosts:
          - http:
            paths:
              - path: /
                pathType: Prefix
                backend:
                  service:
                    name: hyperswitch-web
                    port:
                      number: 80

    hyperswitch-app:
      initDB:
        enable: true
      loadBalancer:
        targetSecurityGroup: *lb_security_group
      services:
        router:
          version: v1.111.0
          image: juspaydotin/hyperswitch-router:v1.111.0-standalone
          host: *router_host
        consumer:
          image: juspaydotin/hyperswitch-consumer:v1.111.0-standalone
        producer:
          image: juspaydotin/hyperswitch-producer:v1.111.0-standalone
        controlCenter:
          image: juspaydotin/hyperswitch-control-center:v1.33.0
        sdk:
          host: *web_sdk_host
          version: 0.80.0
          subversion: v0
      hyperswitch-card-vault:
        enabled: true
        server:
          image: juspaydotin/hyperswitch-card-vault:v0.4.0
          secrets:
            master_key: 7fe40608201400da9db95bb5cc090b2280405617a5ab42f2f6f94e6213d773e95585bf685f79bdc6368fc1e3aa7df984e3dafc6516bcee35bf64b52f
        initDB:
          enable: false
